/* global $, document */
$(function () {

	/**************************VARIABLES****************************/
	
	var moltiplicatore = "";
	var moltiplicando = "";
	var n = 0;
    var counter = 0;
    var decoded = "";
	var risultato = "";
	var cont = 0;
	var risultatoBitPair = "";
	var risultatoadd;
	var risultatoaddpair;
	var passo;
	var passobit;
	var finished = false;
	var addendo = "";
	var pairlength = 8;
	var doBitPair = false;
	var counterBitPair = 0;
	var varBitPair = 0;
	var multiplicandSign = "+";
	var multiplicatorSign = "+";
	
	/*******************************BIT VARIABLES******************************************/
	
	var bitSize = 0;
	var shift = 0;
	
	/*******************************STEP STRING******************************************/
	
	var firstStep = "<div id='terzariga' class='row'><div id='description1' class='col-md-10'><h2 class='stempcounter'>1. Encode the Multiplicator</h2><h4 class='stempdescription'>Here you can observe how the multiplicator is encoded for using it in the Booth multiplication:<br>the factor is read from the most significant bit to the least significant one (left to right), and the read bit value is considered together with the one at its right. The least significant bit is assumed to have '0' at its right side.<br>Then, a new value is obtained from the considered digits.<br>00 -> 0<br>01 -> +1 <br>10 -> -1 <br>11 -> 0<br>The obtained value is put in the encoded string in the same position of the considered bit.</h4></div>";
	var firstStepResult = "<div class='operations'><div id='dec' class='col-md-5'><h4>Considered couple of digits:</h4></div><div id='enc' class='col-md-6'><h4>Encoded string:</h4><div id='result'></div></div></div></div>";
	var secondoStep = "<div id='quartariga' class='row'><div id='description2' class='col-md-10'><h2 class='stempcounter'>2. The Multiplication.</h2><h4 class='stempdescription'> The first factor can be multiplied with the string we have obtained through the Booth code.<br>The multiplication is comparable to the classic algorithm for multiplication. The encoded string  must be read from right to left (in order of increasing significance). We multiply the multiplicand with the value of the considered bit. If the digit is '0' or '+1' the multiplication works exactly as a normal multiplication between two numbers. If the encoded digit is <br>'-1', the summand which will be added to the product will be the two-complement of the multiplicand.<br>Once that all the summand to add to the partial product have been obtained, they will be extended with a sign to a length that is twice that of the factors and, subsequently, they will be summed.</h4></div></div>";
	var secondoStepResult = "<div id='dec1' class='col-md-10'><div id='layout'></div><div id = 'result3'></div><div id = 'finalResult'></div></div>";
	var pairStep = "<div id='testBit-Pair' class='row'><div id='description3' class='col-md-10'><h2 class='stempcounter'>2. Bit-Pair Recode</h2><h4 class='stempdescription'>The moltiplicator can be shortened obtaining its bit-pair form from the Booth's form:<br>This will surely halve the number of the encoded digits, and so also the execution time will be halved.<br>The steps are exactly the same ones of the Booth's Algoritm, but the process will map each pair of adiacents Booth encoded digits to a single recoded digit.<br>The new value is obtained by adding the two digits, through giving double weight to the digit on the left.<br>So, this will be the new table:<br>00 -> 0<br>0+1 -> +1<br>0-1 -> -1<br>+1-1 -> +1<br>-1+1 -> -1<br>+10 -> +2<br>-10 -> -2<br>Note that the values +1+1 and -1-1 are absent in the table. This is because it is impossible to find such adiacent pairs in Booth coded multiplier.</h4></div>";
	var pairStepResult = "<h3><div id='pair' class='col-md-7'><h4>Considered pairs of encoded digits:</h4></div><div id='enc2' class='col-md-5'><h4>Bit-Pair string:</h4><div id='result2'></div></h3></div></div>";
	var secondoStepPair = "<div id='quintariga' class='row'><div id='description3' class='col-md-10'><h2 class='stempcounter'>3. The Multiplication.</h2><h4 class='stempdescription'>After decoding the bit-pair sequence of the multiplicand, we proceed to the multiplication<br>The algorithm is quite alike the simple multiplication between two binary numbers.<br>When the recorded multiplier digit is 0, zero will be written in the following line.<br>When it is +1, a copy of the multiplier will be written in the following line.<br>When the encoded digit is +2, the copy will be written and shifted to the left of one position.<br>So, when the multiplier's digit is -1 or -2 we'll write the two-complement of the multiplier, shifting it to the left in the second case.<br>Finally, after the bit-pair string has been completely read, the final result will be obtained by adding all the numbers we have found, each one extended with a sign to a length that is twice that of the factors.<h4></div>";
	var secondoStepPairResult = "<div id='last' class='col-md-10'><div id='iputnumbershere'></div><div id = 'result4'></div><div id = 'finalPairResult'></div></div></div>";
	
	/***********************FUNZIONI***********************/
	
	//Function used for select in bold actual multiplier's number used during multiplication
	var toView = function(decodedNumber){
		var i = 0;
		var view = "";
		//while loop which underlines multiplier's number used in multiplication 
		while(i < decodedNumber.length){
			if( i == decodedLength-1 || (decodedLength == 0 && i == decodedLength)){
				if(decodedNumber[i] == "-" || decodedNumber[i] == "+"){
					view += "<b>" + decodedNumber[i] + decodedNumber[i+1] + "</b>";
					i += 2;
					decodedLength -= 2;
				}
				else if((decodedLength == 0 && i == decodedLength)){
					view += "<b>" + decodedNumber[i] + "</b>";
					i++;
					decodedLength--;
				}
				else{
					view += decodedNumber[i] + "<b>" + decodedNumber[i+1] + "</b>";
					i += 2;
					decodedLength--;
					}
			}
			else{
				view += decodedNumber[i];
				i++;
			}
		}
		return view;
	}
	
	//Random number generator
	var randomNumberGenerator = function(){
		var randomNumber = "";
		//if bit size = 8 bit it generates a number between -128 and 127
		if(recoverySize() == 8){
			if(Math.round(Math.random()*10)%2 == 0){
				randomNumber = Math.round(Math.random()*127);
			}
			else{
				randomNumber = Math.round(Math.random()*128);
				randomNumber = "-" + randomNumber;
			}
		}
		//if size = 16 bit it generates a number between -32.768 and +32.767
		else{
			if(Math.round(Math.random()*10)%2 == 0){
				randomNumber = Math.round(Math.random()*32767);
			}
			else{
				randomNumber = Math.round(Math.random()*32768);
				randomNumber = "-" + randomNumber;
			}
		}
		return randomNumber;
	};
	
	//Disable interface algorithm
	var	disableInterface = function(){
		$("#nextstepButton").attr("disabled", false);
		$("#multiplicator").attr("disabled", true);
		$("#multiplicand").attr("disabled", true);
		$("#random").attr("disabled", true);
		$("#submits").attr("disabled", true);
		$("#bitSize").attr("disabled", true);
		$("#decodType").attr("disabled", true);
	};
	//BitSize Recovery
	var recoverySize = function(){
		//Take selected option and set bit
		var valueSelected  = $("#bitSize").val()
		var bit = 0;
		if(valueSelected == "16 bit"){
			bit = 16;
		}
		else{
			bit = 8;
		}
		return bit;
	};
	
	//Booth decode algorithm
   var boothSubmit = function () {
		//Select next two number for decodeBooth
        var temp = moltiplicatore[counter] + moltiplicatore[counter + 1];
        var nuovo = decodeBooth(temp);
		risultato += nuovo;
		//Show result of decodeBooth
        $("#result").append(risultato + "<br>");
		decoded += nuovo;
    };


    //bit pair decode algorithm
    var pairSubmit = function () {
    	var num = 0;
    	var temp = "";
    	for(var i=0; i<2; i++){
    		if(risultato[counterBitPair + num] == "0"){
    			temp += "0";
    			num++;
    		}
    		else if((risultato[counterBitPair + num] == "-")||(risultato[counterBitPair + num] == "+")){
    			temp += risultato[counterBitPair + num] + "1";
    			num += 2;
    		}
    	}
    	var nuovo = decodePair(temp);
    	risultatoBitPair += nuovo;
    	$("#result2").append(risultatoBitPair + "<br>")
    	return num;
    };

	//Booth's decode table
    var decodeBooth = function (toDecode) {
        if (toDecode == "00") {
            return "0";
        }
        if (toDecode == "01") {
            return "+1";
        }
        if (toDecode == "10") {
            return "-1";
        }
        if (toDecode == "11") {
            return "0";
        }
    };
	//Bit Pair's decode table
    var decodePair = function (decodeMe){
    	if(decodeMe == "00"){
    		return "0";
    	}
    	else if(decodeMe == "0+1"){
    		return "+1";
    	}
    	else if(decodeMe == "0-1"){
    		return "-1";
    	}
    	else if(decodeMe == "+10"){
    		return "+2";
    	}
    	else if(decodeMe == "+1-1"){
    		return "+1";
    	}
    	else if(decodeMe == "-1+1"){
    		return "-1";
    	}
    	else if(decodeMe == "-10"){
    		return "-2";
    	}
    };
	 
	var update = function (contatore) {
        var toIns = "<text>";
        boothSubmit();
		//Highlight the figures involved in decoding
        for (var i = 0; i < n - 1; i++) {
            if (i == contatore || i == contatore + 1) {
                toIns += "<b>" + moltiplicatore[i] + "</b>";
            } else {
                toIns += moltiplicatore[i];
            }
        }
        toIns += "</text><br>";
        $("#dec").append(toIns);
    };
	
	/*****************************SELECTORS************************************/
	//Change the function of the program between Booth code or Bit-Pair
	$("#decodType").on("change", function(){
		 var valueSelected  = $("#decodType").val()
		 if(valueSelected == "Bit-Pair"){
			doBitPair = true;
		 }
		 else{
			doBitPair = false;
		 }
	});
	
	//Change max size of multiplicand and multiplicator
	$("#bitSize").on("change", function(){
		 var valueSelected  = $("#bitSize").val()
		 if(valueSelected == "16 bit"){
			$("#multiplicand").attr('maxlength',6);
			$("#multiplicator").attr('maxlength',6);
		 }
		 else{
			$("#multiplicand").attr('maxlength',4);
			$("#multiplicator").attr('maxlength',4);
		 }
		 $("#multiplicand").val("");
		 $("#multiplicator").val("");
	});
	
	/*****************************BUTTON***********************************/
	//Refresh page and reset variables 
	$("#refresh").on("click", function(){
		$("#nextstepButton").attr("disabled", true);
		$("#multiplicator").attr("disabled", false);
		$("#multiplicand").attr("disabled", false);
		$("#multiplicator").val("");
		$("#multiplicand").val("");
		$("#random").attr("disabled", false);
		$("#submits").attr("disabled", false);
		$("#bitSize").attr("disabled", false);
		$("#decodType").attr("disabled", false);
		$("#decodType").prop('selectedIndex', 0);
		$("#bitSize").prop('selectedIndex', 0);
		moltiplicatore = "";
		moltiplicando = "";
		n = 0;
		counter = 0;
		decoded = "";
		risultato = "";
		cont = 0;
		risultatoBitPair = "";
		risultatoadd = "";
		risultatoaddpair = "";
		passo = 0;
		passobit = 0;
		finished = false;
		addendo = "";
		pairlength = 8;
		doBitPair = false;
		counterBitPair = 0;
		varBitPair = 0;
		multiplicandSign = "+";
		multiplicatorSign = "+";
		bitSize = 0;
		shift = 0;
		window.location.reload();
	});
	
	/********************NEXT STEP BUTTON'S FUNCTIONS***********************/
	
	//Append first step description on left scrollbar
	var showFirstStep = function(){
		$("#scrollBar").append(firstStep);
		$("#scrollBarResult").append(firstStepResult);
	}
	
	//Append pair step description on left scrollbar
	var showPairStep = function (){
		$("#scrollBar").append(pairStep);
		document.getElementById("testBit-Pair").scrollIntoView();
		$("#scrollBarResult").append(pairStepResult);
	}
	
	//Bit Pair's Coding
	var pairCoding = function(){
		var insert = "<text>";
		var m = risultato.length;
		var inc = pairSubmit(); 
		for(var i = 0; i<m; i++){
			if (i >= counterBitPair && i < counterBitPair + inc) {
			insert += "<b>" + risultato[i] + "</b>";
			} 
			else {
			insert += risultato[i];
			}
		}
		insert += "</text><br>";
		$("#pair").append(insert);
		document.getElementById("pair").scrollIntoView();
		counterBitPair += inc;
	}
	
	var secondStepBooth = function(){
		//Append second step description on left scrollbar
		$("#scrollBar").append(secondoStep);
		//Append result of booth's coding
		$("#scrollBarResult").append(secondoStepResult);
        var toApp = "<br>" + moltiplicando + "<br>" + decoded + "<br>";
		//Append multiplicand and multiplier (booth's coding) on right scrollbar
        $("#layout").append(toApp);
		decodedLength = decoded.length-1;
        document.getElementById("layout").scrollIntoView();
		document.getElementById("quartariga").scrollIntoView();
		passo = decoded.length-1;
	}
	
	var secondStepPair = function(){
				passo = -1;
				finished = true;
				passobit = risultatoBitPair.length-1;
				//Append second step pair description on left scrollbar
				$("#scrollBar").append(secondoStepPair);
				//Append multiplicand and multiplier (bit-pair's coding) on right scrollbar
				$("#scrollBarResult").append(secondoStepPairResult);
				var appendi = "<br>" + moltiplicando + "<br>" + risultatoBitPair + "<br>";
				$("#iputnumbershere").append(appendi);
				decodedLength = risultatoBitPair.length-1;
				document.getElementById("result4").scrollIntoView();
				document.getElementById("quintariga").scrollIntoView();
				shift = recoverySize();
	}
	
	var boothMultiplication = function(){
			//refresh layout 
			$("#layout").empty();
			var tmp = toView(decoded);
			var toApp = "<br>" + moltiplicando + "<br>" + tmp + "<br>";
			$("#layout").append(toApp);
			//Star multiplication
			addendo = half_row(moltiplicando, decoded, passo);
			var zeros = (addendo.length)-(shift)
			addendo = row(addendo, zeros);
			risultatoadd = sum(risultatoadd, addendo);
			var colonnaddendo = "";
			//Show result of multiplication between "moltiplicando" and i-th number of "moltiplicatore"
			for(var i=0; i<addendo.length; i++){
				if(addendo.length-i > zeros){
					colonnaddendo += addendo[i];
				}
				else{
					colonnaddendo += "_";
				}
			}
			$("#result3").append(colonnaddendo + "<br>");
			document.getElementById("result3").scrollIntoView();
			passo--;
			shift--;
	}
	
	var showBoothMultiplicationResult = function(){
			//Show final result of multiplication
			$("#finalResult").append(risultatoadd + "<br><br>");
			document.getElementById("finalResult").scrollIntoView();
			passobit = risultatoBitPair.length;
			finished = true;
	}
	
	var bitPairMultiplication = function(){
			//Refresh iputnumbershere 
			$("#iputnumbershere").empty();
			var tmp = toView(risultatoBitPair);
			var toApp = "<br>" + moltiplicando + "<br>" + tmp + "<br>";
			$("#iputnumbershere").append(toApp);
			//Start bitpair multiplcation
			var addendopair = half_row(moltiplicando, risultatoBitPair, passobit);
			var zero2 = (pairlength)-(shift);
			addendopair = row(addendopair, zero2);
			risultatoaddpair = sum(risultatoaddpair, addendopair);
			var colonnabit = "";
			//Show result of multiplication between "moltiplicando" and i-th number of "moltiplicatore"
			for(var i=0; i<addendopair.length; i++){
				if(addendopair.length-i > zero2){
					colonnabit += addendopair[i];
				}
				else{
					colonnabit += "_";
				}
			}
			passobit--;
			shift = shift - 2;
			$("#result4").append(colonnabit + "<br>");
			document.getElementById("result4").scrollIntoView();
	}
	
	var showBitPairMultiplicationResult = function(){
			//Show final result of bit-pair multiplication
			$("#finalPairResult").append(risultatoaddpair + "<br><br>");
			document.getElementById("finalPairResult").scrollIntoView();
			passobit--;
	}
	
	/***********************NEXT STEP BUTTON***************************/
	
	$("#nextstepButton").on("click", function () {
        if (counter < n - 1) {
            if(counter == 0){
			//Show firstStep on scroll bar
				showFirstStep();
            }
			//Used for booth decode
			update(counter);
			if(counter == n-2 && !doBitPair){
				counter = n+varBitPair-1;
			}
        }
        // After counter > n-1 "nextStepButton" do bit-pair decode (only if bitpair decode was selected)
        else if (counter < n + varBitPair ){
				if(counter == n-1){
				//Show pairStep on scroll bar
					showPairStep();
				}
				if(counterBitPair < risultato.length){
				//Do and show bit pair decode
					pairCoding();
				}
        } else if(counter == n + varBitPair) {
			//Show secondStep on scroll bar
            if(!doBitPair){
				secondStepBooth();
			}
			else{
				secondStepPair();
			}
        }
		else if(counter > n+varBitPair && passo >= 0) {
			boothMultiplication();
		}
		else if(passo < 0 && !finished)
		{	
			showBoothMultiplicationResult();
		}
		else if(passobit >= 0 && doBitPair)
		{	
			bitPairMultiplication();
		}
		else if(passobit == -1 && doBitPair)
		{	
			showBitPairMultiplicationResult();
		}
        counter++;
    });
	
	/***************SUBMIT******************/
	
	//Submit values to be multiplied
	$("#submits").on("click", function (){
		bitSize = recoverySize();
		shift = bitSize;
		if(recoverySize() == 8){
			risultatoadd = "0000000000000000";
			risultatoaddpair = "0000000000000000";
		}
		else{
			risultatoadd = "00000000000000000000000000000000";
			risultatoaddpair = "00000000000000000000000000000000";
		}
		//Absence control values
		if($("#multiplicand").val() == ""){
			var randomMultiplicand = randomNumberGenerator();
			$("#multiplicand").val(randomMultiplicand);
		}
		if($("#multiplicator").val() == ""){
			var randomMultiplicator = randomNumberGenerator();
			$("#multiplicator").val(randomMultiplicator);
		}		
		//Values assignment
		moltiplicatore = $("#multiplicator").val();
		moltiplicando = $("#multiplicand").val();
		if((((moltiplicando < -128 || moltiplicando > 127) ||(moltiplicatore < -128 || moltiplicatore > 127))  && recoverySize() == 8) ||
		   (((moltiplicando < -32768 || moltiplicando > 32767) ||(moltiplicatore < -32768 || moltiplicatore > 32767))  && recoverySize() == 16)){
			alert("Out of range!\nMax numbers you can represent are:\n8bit: from -128 to 127\n16bit: from -32768 to 32767\nPlease retry.");
			multiplicand.value = "";
			multiplicator.value = "";
			return;
		}
		if(moltiplicatore[0] == "-"){
			var tmp = "";
			multiplicatorSign = "-";
			for(var j = 1;j < moltiplicatore.length;j++){
				tmp += moltiplicatore[j];
			}
			moltiplicatore = tmp;
		}
		if(moltiplicando[0] == "-"){
			var tmp = "";
			multiplicandSign = "-";
			for(var j = 1;j < moltiplicando.length;j++){
				tmp += moltiplicando[j];
			}
			moltiplicando = tmp;
		}
		
		
		var decMoltiplicatore = parseInt(moltiplicatore);
		var decMoltiplicando = parseInt(moltiplicando);
		if (isNaN(decMoltiplicando) || isNaN(decMoltiplicatore))
		{
			alert("Hai inserito un valore che non e' un numero decimale. Modifica il valore e riclicca submit");
			return;
		}
		moltiplicatore = decMoltiplicatore.toString(2);
		moltiplicando = decMoltiplicando.toString(2);
		
		//Button disable
		disableInterface();
		
		//"moltiplicatore" 's sign extension + add "0"
		moltiplicatore += "0";
		while(moltiplicatore.length < bitSize+1){
			moltiplicatore = "0" + moltiplicatore;
		}
		//"moltiplicando" 's sign extension
		while(moltiplicando.length < bitSize){
			moltiplicando = "0" + moltiplicando;
		}
		if(multiplicandSign == "-"){
			moltiplicando = doTwoComplement(moltiplicando);
		}
		if(multiplicatorSign == "-"){
			moltiplicatore = doTwoComplement(moltiplicatore);
		}
		$("#multiplicandBin").val(moltiplicando + " converted from " + multiplicandSign + decMoltiplicando);
		$("#multiplicatorBin").val(moltiplicatore + " converted from " + multiplicatorSign + decMoltiplicatore);
		//initialization of n
		n = moltiplicatore.length;
		if(recoverySize() == 8){
			varBitPair = 3;
			pairlength = 8;
		}
		else{
			varBitPair = 7;
			pairlength = 16;
		}
	});
	
	//Button for the random generation of the inputs
	$("#random").on("click",function(){
		
		var randomMultiplicator = randomNumberGenerator();
		var randomMultiplicand = randomNumberGenerator();
		$("#multiplicand").val(randomMultiplicand);
		$("#multiplicator").val(randomMultiplicator);
		return;
	});
	
	
	/*********************MULTIPLICATION'S CODE*********************/
	
	//Multiplication between multiplicand ad i-th number of multiplier
	var half_row = function (multiplicandUsed, multiplicatorUsed, i){	
		if(bitSize == 8){
				zeroResult = "00000000";
		}
		else{
				zeroResult = "0000000000000000";
		}
		if(multiplicatorUsed[i]=="1"){
			i--;
			passo--;
			passobit--;
			if(multiplicatorUsed[i] == "+"){
			return multiplicandUsed;
			}
			else{
			var twoComplement = doTwoComplement(multiplicandUsed);
			return twoComplement;
			}
		}
		if(multiplicatorUsed[i] == "2"){
			i--;
			passobit--;
			if(multiplicatorUsed[i] == "+"){
				var toRet = multiplicandUsed + "0";
				return toRet;
			}
			else{
				var twoComplement = doTwoComplement(multiplicandUsed);
				twoComplement = twoComplement + "0";
				return twoComplement;
			}
		}
		return zeroResult;
	};
	//Do two complement of multiplicandUsed 
	var doTwoComplement=function (number){
		var complement  = "";
		var i;
		for(i=number.length-1; i>=0; i--){
			if(number[i]=="1"){
				complement = "0"+complement;
			}
			else{
				complement = "1"+complement;
			}
		}
		var numOne = "1";
		for(i=number.length-2; i>=0; i--){
			numOne = "0" + numOne;
		}
		complement = sum(complement, numOne);
		return complement;
	};	
	
	var row= function (num,zero_after)
	{
		var i=num.length-zero_after;
		if(num.length == 9 || num.length == 17){
			i = i-2;
		}
		var p = zero_after;
		if(num[0] == "0"){
			for(i; i>0; i--){
				num = "0" + num;
			}
		}
		else{
			for(i; i>0; i--){
				num = "1" + num;
			}
		}
		for(p; p>0; p--){
			num = num + "0";
		}
		return num;
	};
	
	var sum = function (add1,add2){
		var res = "";
		var rip = 0;
		for(var i=add1.length-1; i>=0; i--){
			if(add1[i]=="0" && add2[i]=="0"){
				if(rip == 0){	
					res = "0" + res;
				}
				else{
					res = "1"+res;
					rip = 0;
				}
			}				
			else if(add1[i] != add2[i]){
				if(rip == 0){
					res = "1" + res;
				}
				else{		
					res = "0" + res;
				}
			}                      
			else{
				if(rip == 0){        			
					res = "0" + res;
					rip = 1;
				}
				else{
					rip = 1;
					res = "1" + res;
				}
			}
		}
		return res;
	};

});
